"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _sleepPromise = _interopRequireDefault(require("sleep-promise"));

var _terminal = _interopRequireDefault(require("terminal.js"));

var _decode = _interopRequireDefault(require("../../utils/decode"));

var _encode = _interopRequireDefault(require("../../utils/encode"));

var _keymap = _interopRequireDefault(require("../../utils/keymap"));

var _char = require("../../utils/char");

var _config = _interopRequireDefault(require("./config"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Condition =
/*#__PURE__*/
function () {
  function Condition(type, criteria) {
    (0, _classCallCheck2["default"])(this, Condition);
    (0, _defineProperty2["default"])(this, "typeWord", void 0);
    (0, _defineProperty2["default"])(this, "criteria", void 0);

    switch (type) {
      case 'push':
        this.typeWord = 'Z';
        break;

      case 'author':
        this.typeWord = 'a';
        break;

      case 'title':
        this.typeWord = '/';
        break;

      default:
        throw "Invalid condition: ".concat(type);
    }

    this.criteria = criteria;
  }

  (0, _createClass2["default"])(Condition, [{
    key: "toSearchString",
    value: function toSearchString() {
      return "".concat(this.typeWord).concat(this.criteria);
    }
  }]);
  return Condition;
}();

var Bot =
/*#__PURE__*/
function (_EventEmitter) {
  (0, _inherits2["default"])(Bot, _EventEmitter);

  function Bot(config) {
    var _this;

    (0, _classCallCheck2["default"])(this, Bot);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Bot).call(this));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "searchCondition", {
      conditions: null,
      init: function init() {
        this.conditions = [];
      },
      add: function add(type, criteria) {
        this.conditions.push(new Condition(type, criteria));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getLine", function (n) {
      return _this._term.state.getLine(n);
    });
    _this.config = _objectSpread({}, _config["default"], {}, config);

    _this.init();

    return _this;
  }

  (0, _createClass2["default"])(Bot, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      var config = this.config;
      this._term = new _terminal["default"](config.terminal);
      this._state = _objectSpread({}, Bot.initialState);

      this._term.state.setMode('stringWidth', 'dbcs');

      this.currentCharset = 'big5';
      var Socket;

      switch (config.protocol.toLowerCase()) {
        case 'websocket':
        case 'ws':
        case 'wss':
          Socket = require("../../socket")["default"];
          break;

        case 'telnet':
        case 'ssh':
        default:
          Socket = null;
      }

      if (Socket === null) {
        throw "Invalid protocol: ".concat(config.protocol);
      }

      var socket = new Socket(config);
      socket.connect();
      Bot.forwardEvents.forEach(function (e) {
        socket.on(e, _this2.emit.bind(_this2, e));
      });
      socket.on('connect', function () {
        _this2._state.connect = true;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this2.emit.apply(_this2, ['connect'].concat(args));

        _this2.emit('stateChange', _this2.state);
      }).on('disconnect', function (closeEvent) {
        _this2._state.connect = false;

        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        _this2.emit.apply(_this2, ['disconnect', closeEvent].concat(args));

        _this2.emit('stateChange', _this2.state);
      }).on('message', function (data) {
        if (_this2.currentCharset != _this2.config.charset && !_this2.state.login && (0, _decode["default"])(data, 'utf8').includes('登入中，請稍候...')) {
          _this2.currentCharset = _this2.config.charset;
        }

        var msg = (0, _decode["default"])(data, _this2.currentCharset);

        _this2._term.write(msg);

        _this2.emit('redraw', _this2._term.toString());
      }).on('error', function (err) {});
      this.socket = socket;
    }
  }, {
    key: "getLines",
    value: function () {
      var _getLines = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var getLine, lines, i, lastLine, _i, j;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                getLine = this.getLine;
                lines = [];
                lines.push(getLine(0).str);

              case 3:
                if (getLine(23).str.includes("100%")) {
                  _context.next = 9;
                  break;
                }

                for (i = 1; i < 23; i++) {
                  lines.push(getLine(i).str);
                }

                _context.next = 7;
                return this.send(_keymap["default"].PgDown);

              case 7:
                _context.next = 3;
                break;

              case 9:
                lastLine = lines[lines.length - 1];
                _i = 0;

              case 11:
                if (!(_i < 23)) {
                  _context.next = 18;
                  break;
                }

                if (!(getLine(_i).str == lastLine)) {
                  _context.next = 15;
                  break;
                }

                for (j = _i + 1; j < 23; j++) {
                  lines.push(getLine(j).str);
                }

                return _context.abrupt("break", 18);

              case 15:
                _i++;
                _context.next = 11;
                break;

              case 18:
                while (lines.length > 0 && lines[lines.length - 1].length == 0) {
                  lines.pop();
                }

                return _context.abrupt("return", lines);

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getLines() {
        return _getLines.apply(this, arguments);
      }

      return getLines;
    }()
  }, {
    key: "send",
    value: function () {
      var _send = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(msg) {
        var _this3 = this;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.config.preventIdleTimeout && this.preventIdle(this.config.preventIdleTimeout);
                return _context2.abrupt("return", new Promise(function (resolve) {
                  if (_this3.state.connect) {
                    _this3.socket.send((0, _encode["default"])(msg, _this3.currentCharset));

                    _this3.once('message', function (msg) {
                      resolve(msg);
                    });
                  }
                }));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function send(_x) {
        return _send.apply(this, arguments);
      }

      return send;
    }()
  }, {
    key: "preventIdle",
    value: function preventIdle(timeout) {
      var _this4 = this;

      clearTimeout(this.preventIdleHandler);

      if (this.state.login) {
        this.preventIdleHandler = setTimeout(
        /*#__PURE__*/
        (0, _asyncToGenerator2["default"])(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee3() {
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.next = 2;
                  return _this4.send(_keymap["default"].CtrlU);

                case 2:
                  _context3.next = 4;
                  return _this4.send(_keymap["default"].ArrowLeft);

                case 4:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        })), timeout * 1000);
      }
    }
  }, {
    key: "login",
    value: function () {
      var _login = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4(username, password) {
        var kick,
            ret,
            state,
            _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                kick = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : true;

                if (!this.state.login) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return");

              case 3:
                username = username.replace(/,/g, '');

                if (this.config.charset === 'utf8') {
                  username += ',';
                }

                _context4.next = 7;
                return this.send("".concat(username).concat(_keymap["default"].Enter).concat(password).concat(_keymap["default"].Enter));

              case 7:
                _context4.next = 9;
                return this._checkLogin(kick);

              case 9:
                _context4.t0 = ret = _context4.sent;

                if (!(_context4.t0 === null)) {
                  _context4.next = 15;
                  break;
                }

                _context4.next = 13;
                return (0, _sleepPromise["default"])(400);

              case 13:
                _context4.next = 7;
                break;

              case 15:
                if (ret) {
                  state = this._state;
                  state.login = true;
                  state.position = {
                    boardname: ""
                  };
                  this.searchCondition.init();
                  this.emit('stateChange', this.state);
                }

                return _context4.abrupt("return", ret);

              case 17:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function login(_x2, _x3) {
        return _login.apply(this, arguments);
      }

      return login;
    }()
  }, {
    key: "logout",
    value: function () {
      var _logout = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5() {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (this.state.login) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt("return");

              case 2:
                _context5.next = 4;
                return this.send("G".concat(_keymap["default"].Enter, "Y").concat(_keymap["default"].Enter.repeat(2)));

              case 4:
                this._state.login = false;
                this.emit('stateChange', this.state);
                return _context5.abrupt("return", true);

              case 7:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function logout() {
        return _logout.apply(this, arguments);
      }

      return logout;
    }()
  }, {
    key: "_checkLogin",
    value: function () {
      var _checkLogin2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee6(kick) {
        var getLine;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                getLine = this.getLine;

                if (!getLine(21).str.includes("密碼不對或無此帳號")) {
                  _context6.next = 6;
                  break;
                }

                this.emit('login.failed');
                return _context6.abrupt("return", false);

              case 6:
                if (!getLine(23).str.includes("請稍後再試")) {
                  _context6.next = 11;
                  break;
                }

                this.emit('login.failed');
                return _context6.abrupt("return", false);

              case 11:
                if (!getLine(22).str.includes("您想刪除其他重複登入的連線嗎")) {
                  _context6.next = 16;
                  break;
                }

                _context6.next = 14;
                return this.send("".concat(_keymap["default"].Backspace).concat(kick ? 'y' : 'n').concat(_keymap["default"].Enter));

              case 14:
                _context6.next = 43;
                break;

              case 16:
                if (!getLine(23).str.includes("請勿頻繁登入以免造成系統過度負荷")) {
                  _context6.next = 21;
                  break;
                }

                _context6.next = 19;
                return this.send("".concat(_keymap["default"].Enter));

              case 19:
                _context6.next = 43;
                break;

              case 21:
                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context6.next = 26;
                  break;
                }

                _context6.next = 24;
                return this.send("".concat(_keymap["default"].Enter));

              case 24:
                _context6.next = 43;
                break;

              case 26:
                if (!getLine(23).str.includes("您要刪除以上錯誤嘗試的記錄嗎")) {
                  _context6.next = 31;
                  break;
                }

                _context6.next = 29;
                return this.send("".concat(_keymap["default"].Backspace, "y").concat(_keymap["default"].Enter));

              case 29:
                _context6.next = 43;
                break;

              case 31:
                if (!(getLine(22).str + getLine(23).str).toLowerCase().includes("y/n")) {
                  _context6.next = 36;
                  break;
                }

                _context6.next = 34;
                return this.send("".concat(_keymap["default"].Backspace, "y").concat(_keymap["default"].Enter));

              case 34:
                _context6.next = 43;
                break;

              case 36:
                if (!getLine(23).str.includes("我是")) {
                  _context6.next = 41;
                  break;
                }

                this.emit('login.success');
                return _context6.abrupt("return", true);

              case 41:
                _context6.next = 43;
                return this.send("q");

              case 43:
                return _context6.abrupt("return", null);

              case 44:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _checkLogin(_x4) {
        return _checkLogin2.apply(this, arguments);
      }

      return _checkLogin;
    }()
  }, {
    key: "_checkArticleWithHeader",
    value: function _checkArticleWithHeader() {
      var authorArea = (0, _char.substrWidth)('dbcs', this.getLine(0).str, 0, 6).trim();
      return authorArea === "作者";
    }
  }, {
    key: "setSearchCondition",
    value: function setSearchCondition(type, criteria) {
      this.searchCondition.add(type, criteria);
    }
  }, {
    key: "resetSearchCondition",
    value: function resetSearchCondition() {
      this.searchCondition.init();
    }
  }, {
    key: "isSearchConditionSet",
    value: function isSearchConditionSet() {
      return this.searchCondition.conditions.length !== 0;
    }
  }, {
    key: "getArticles",
    value: function () {
      var _getArticles = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee7(boardname) {
        var offset,
            searchString,
            getLine,
            articles,
            i,
            line,
            article,
            _i2,
            _i3,
            _args7 = arguments;

        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                offset = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : 0;
                _context7.next = 3;
                return this.enterBoard(boardname);

              case 3:
                if (!this.isSearchConditionSet()) {
                  _context7.next = 7;
                  break;
                }

                searchString = this.searchCondition.conditions.map(function (condition) {
                  return condition.toSearchString();
                }).join(_keymap["default"].Enter);
                _context7.next = 7;
                return this.send("".concat(searchString).concat(_keymap["default"].Enter));

              case 7:
                offset |= 0;

                if (!(offset > 0)) {
                  _context7.next = 12;
                  break;
                }

                offset = Math.max(offset - 9, 1);
                _context7.next = 12;
                return this.send("".concat(_keymap["default"].End).concat(_keymap["default"].End).concat(offset).concat(_keymap["default"].Enter));

              case 12:
                getLine = this.getLine;
                articles = [];

                for (i = 3; i <= 22; i++) {
                  line = getLine(i).str;
                  article = {
                    sn: (0, _char.substrWidth)('dbcs', line, 1, 7).trim() | 0,
                    push: (0, _char.substrWidth)('dbcs', line, 9, 2).trim(),
                    date: (0, _char.substrWidth)('dbcs', line, 11, 5).trim(),
                    author: (0, _char.substrWidth)('dbcs', line, 17, 12).trim(),
                    status: (0, _char.substrWidth)('dbcs', line, 30, 2).trim(),
                    title: (0, _char.substrWidth)('dbcs', line, 32).trim(),
                    fixed: (0, _char.substrWidth)('dbcs', line, 1, 7).trim().includes('★')
                  };
                  articles.push(article);
                } // fix sn


                if (!(articles.length >= 2 && articles[0].sn === 0)) {
                  _context7.next = 24;
                  break;
                }

                _i2 = 1;

              case 17:
                if (!(_i2 < articles.length)) {
                  _context7.next = 24;
                  break;
                }

                if (!(articles[_i2].sn !== 0)) {
                  _context7.next = 21;
                  break;
                }

                articles[0].sn = articles[_i2].sn - _i2;
                return _context7.abrupt("break", 24);

              case 21:
                _i2++;
                _context7.next = 17;
                break;

              case 24:
                for (_i3 = 1; _i3 < articles.length; _i3++) {
                  articles[_i3].sn = articles[_i3 - 1].sn + 1;
                }

                _context7.next = 27;
                return this.enterIndex();

              case 27:
                return _context7.abrupt("return", articles.reverse());

              case 28:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getArticles(_x5) {
        return _getArticles.apply(this, arguments);
      }

      return getArticles;
    }()
  }, {
    key: "getArticle",
    value: function () {
      var _getArticle = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee8(boardname, sn) {
        var searchString, getLine, hasHeader, article;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.enterBoard(boardname);

              case 2:
                if (!this.isSearchConditionSet()) {
                  _context8.next = 6;
                  break;
                }

                searchString = this.searchCondition.conditions.map(function (condition) {
                  return condition.toSearchString();
                }).join(_keymap["default"].Enter);
                _context8.next = 6;
                return this.send("".concat(searchString).concat(_keymap["default"].Enter));

              case 6:
                getLine = this.getLine;
                _context8.next = 9;
                return this.send("".concat(sn).concat(_keymap["default"].Enter).concat(_keymap["default"].Enter));

              case 9:
                hasHeader = this._checkArticleWithHeader();
                article = {
                  sn: sn,
                  author: "",
                  title: "",
                  timestamp: "",
                  lines: []
                };

                if (this._checkArticleWithHeader()) {
                  article.author = (0, _char.substrWidth)('dbcs', getLine(0).str, 7, 50).trim();
                  article.title = (0, _char.substrWidth)('dbcs', getLine(1).str, 7).trim();
                  article.timestamp = (0, _char.substrWidth)('dbcs', getLine(2).str, 7).trim();
                }

                _context8.next = 14;
                return this.getLines();

              case 14:
                article.lines = _context8.sent;
                _context8.next = 17;
                return this.enterIndex();

              case 17:
                return _context8.abrupt("return", article);

              case 18:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getArticle(_x6, _x7) {
        return _getArticle.apply(this, arguments);
      }

      return getArticle;
    }()
  }, {
    key: "getFavorite",
    value: function () {
      var _getFavorite = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee9() {
        var offsets,
            getLine,
            favorites,
            stopLoop,
            i,
            line,
            favorite,
            _args9 = arguments;
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                offsets = _args9.length > 0 && _args9[0] !== undefined ? _args9[0] : [];

                if (typeof offsets === "string") {
                  offsets |= 0;
                }

                if (typeof offsets === "number") {
                  offsets = [offsets];
                }

                _context9.next = 5;
                return this.enterFavorite(offsets);

              case 5:
                getLine = this.getLine;
                favorites = [];

              case 7:
                if (!true) {
                  _context9.next = 37;
                  break;
                }

                stopLoop = false;
                i = 3;

              case 10:
                if (!(i < 23)) {
                  _context9.next = 31;
                  break;
                }

                line = getLine(i).str;

                if (!(line.trim() === '')) {
                  _context9.next = 15;
                  break;
                }

                stopLoop = true;
                return _context9.abrupt("break", 31);

              case 15:
                favorite = {
                  bn: (0, _char.substrWidth)('dbcs', line, 3, 4).trim() | 0,
                  read: (0, _char.substrWidth)('dbcs', line, 8, 2).trim() === '',
                  boardname: (0, _char.substrWidth)('dbcs', line, 10, 12).trim(),
                  category: (0, _char.substrWidth)('dbcs', line, 23, 4).trim(),
                  title: (0, _char.substrWidth)('dbcs', line, 30, 31),
                  users: (0, _char.substrWidth)('dbcs', line, 62, 5).trim(),
                  admin: (0, _char.substrWidth)('dbcs', line, 67).trim(),
                  folder: false,
                  divider: false
                };

                if (!(favorite.bn !== favorites.length + 1)) {
                  _context9.next = 19;
                  break;
                }

                stopLoop = true;
                return _context9.abrupt("break", 31);

              case 19:
                _context9.t0 = favorite.boardname;
                _context9.next = _context9.t0 === 'MyFavFolder' ? 22 : _context9.t0 === '------------' ? 24 : 26;
                break;

              case 22:
                favorite = _objectSpread({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  folder: true
                });
                return _context9.abrupt("break", 27);

              case 24:
                favorite = _objectSpread({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  divider: true
                });
                return _context9.abrupt("break", 27);

              case 26:
                return _context9.abrupt("break", 27);

              case 27:
                favorites.push(favorite);

              case 28:
                i++;
                _context9.next = 10;
                break;

              case 31:
                if (!stopLoop) {
                  _context9.next = 33;
                  break;
                }

                return _context9.abrupt("break", 37);

              case 33:
                _context9.next = 35;
                return this.send(_keymap["default"].PgDown);

              case 35:
                _context9.next = 7;
                break;

              case 37:
                _context9.next = 39;
                return this.enterIndex();

              case 39:
                return _context9.abrupt("return", favorites);

              case 40:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getFavorite() {
        return _getFavorite.apply(this, arguments);
      }

      return getFavorite;
    }()
  }, {
    key: "getMails",
    value: function () {
      var _getMails = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee10() {
        var offset,
            getLine,
            mails,
            i,
            line,
            mail,
            _args10 = arguments;
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                offset = _args10.length > 0 && _args10[0] !== undefined ? _args10[0] : 0;
                _context10.next = 3;
                return this.enterMail();

              case 3:
                offset |= 0;

                if (!(offset > 0)) {
                  _context10.next = 8;
                  break;
                }

                offset = Math.max(offset - 9, 1);
                _context10.next = 8;
                return this.send("".concat(_keymap["default"].End).concat(_keymap["default"].End).concat(offset).concat(_keymap["default"].Enter));

              case 8:
                getLine = this.getLine;
                mails = [];

                for (i = 3; i <= 22; i++) {
                  line = getLine(i).str;
                  mail = {
                    sn: (0, _char.substrWidth)('dbcs', line, 1, 5).trim() | 0,
                    date: (0, _char.substrWidth)('dbcs', line, 9, 5).trim(),
                    author: (0, _char.substrWidth)('dbcs', line, 15, 12).trim(),
                    status: (0, _char.substrWidth)('dbcs', line, 30, 2).trim(),
                    title: (0, _char.substrWidth)('dbcs', line, 33).trim()
                  };
                  mails.push(mail);
                }

                _context10.next = 13;
                return this.enterIndex();

              case 13:
                return _context10.abrupt("return", mails.reverse());

              case 14:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getMails() {
        return _getMails.apply(this, arguments);
      }

      return getMails;
    }()
  }, {
    key: "getMail",
    value: function () {
      var _getMail = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee11(sn) {
        var getLine, hasHeader, mail;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.enterMail();

              case 2:
                getLine = this.getLine;
                _context11.next = 5;
                return this.send("".concat(sn).concat(_keymap["default"].Enter).concat(_keymap["default"].Enter));

              case 5:
                hasHeader = this._checkArticleWithHeader();
                mail = {
                  sn: sn,
                  author: "",
                  title: "",
                  timestamp: "",
                  lines: []
                };

                if (this._checkArticleWithHeader()) {
                  mail.author = (0, _char.substrWidth)('dbcs', getLine(0).str, 7, 50).trim();
                  mail.title = (0, _char.substrWidth)('dbcs', getLine(1).str, 7).trim();
                  mail.timestamp = (0, _char.substrWidth)('dbcs', getLine(2).str, 7).trim();
                }

                _context11.next = 10;
                return this.getLines();

              case 10:
                mail.lines = _context11.sent;
                _context11.next = 13;
                return this.enterIndex();

              case 13:
                return _context11.abrupt("return", mail);

              case 14:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getMail(_x8) {
        return _getMail.apply(this, arguments);
      }

      return getMail;
    }()
  }, {
    key: "enterIndex",
    value: function () {
      var _enterIndex = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee12() {
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.send("".concat(_keymap["default"].ArrowLeft.repeat(10)));

              case 2:
                return _context12.abrupt("return", true);

              case 3:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function enterIndex() {
        return _enterIndex.apply(this, arguments);
      }

      return enterIndex;
    }()
  }, {
    key: "enterBoard",
    value: function () {
      var _enterBoard = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee13(boardname) {
        var getLine;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.send("s".concat(boardname).concat(_keymap["default"].Enter, " ").concat(_keymap["default"].Home).concat(_keymap["default"].End));

              case 2:
                boardname = boardname.toLowerCase();
                getLine = this.getLine;

                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context13.next = 7;
                  break;
                }

                _context13.next = 7;
                return this.send(" ");

              case 7:
                if (!getLine(0).str.toLowerCase().includes("".concat(boardname))) {
                  _context13.next = 11;
                  break;
                }

                this._state.position.boardname = boardname;
                this.emit('stateChange', this.state);
                return _context13.abrupt("return", true);

              case 11:
                return _context13.abrupt("return", false);

              case 12:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function enterBoard(_x9) {
        return _enterBoard.apply(this, arguments);
      }

      return enterBoard;
    }()
  }, {
    key: "enterFavorite",
    value: function () {
      var _enterFavorite = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee14() {
        var offsets,
            enterOffsetMessage,
            _args14 = arguments;
        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                offsets = _args14.length > 0 && _args14[0] !== undefined ? _args14[0] : [];
                enterOffsetMessage = offsets.map(function (offset) {
                  return "".concat(offset).concat(_keymap["default"].Enter.repeat(2));
                }).join();
                _context14.next = 4;
                return this.send("F".concat(_keymap["default"].Enter).concat(_keymap["default"].Home).concat(enterOffsetMessage));

              case 4:
                return _context14.abrupt("return", true);

              case 5:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function enterFavorite() {
        return _enterFavorite.apply(this, arguments);
      }

      return enterFavorite;
    }()
  }, {
    key: "enterMail",
    value: function () {
      var _enterMail = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee15() {
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.send("M".concat(_keymap["default"].Enter, "R").concat(_keymap["default"].Enter).concat(_keymap["default"].Home).concat(_keymap["default"].End));

              case 2:
                return _context15.abrupt("return", true);

              case 3:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function enterMail() {
        return _enterMail.apply(this, arguments);
      }

      return enterMail;
    }()
  }, {
    key: "state",
    get: function get() {
      return _objectSpread({}, this._state);
    }
  }]);
  return Bot;
}(_eventemitter["default"]);

(0, _defineProperty2["default"])(Bot, "initialState", {
  connect: false,
  login: false
});
(0, _defineProperty2["default"])(Bot, "forwardEvents", ['message', 'error']);
var _default = Bot;
exports["default"] = _default;